  persistent global symcontainer, currentsym, rccf, batchSettings
  set1 = #{}
  set2 = #{}
  firstObj = undefined
  secondObj = undefined
  rmCollIndex = undefined
  objSel = #()
  enth = 1
  conth = 1
  --------------------------------------------------------------------------------
  fn isConst obj =
   (
    local state = false
	for cont in helpers do if (classOf cont) == CSolver do if not cont.disabled do for j in cont.constraints do if j==obj do state=true
	state
   )
  --------------------------------------------------------------------------------
  fn isRB obj =
   (
    local state = false
	for cont in helpers do if (classOf cont) == RBCollection do if not cont.disabled do for j in cont.rigidBodies do if j==obj do state=true
	state
   )
  ----------------------------------------------------------------------------
  fn isEntity i = (classOf i == windhelper) or (classOf i == springhelper) or (classOf i == SBCollection) or (classOf i == DMCollection) or (classOf i == A_Dashpot) or (classOf i == CSolver) or (classOf i == Toy_Car) or (classOf i == Fracture) or (classOf i == RPCollection) or (classOf i == CLCollection) or (classOf i == L_Dashpot) or (classOf i == RBCollection) or (classOf i == WaterSpaceWarp) or (classOf i == Motorhelper)
  ----------------------------------------------------------------------------------------------------------------
  fn getEnts objArr =
   (
    local retArr = #()
	for obj in objArr do
	 (
	  if not isDeleted obj do
	   (
	    if (classOf obj == SBCollection) do join retArr obj.softBodies
	    if (classOf obj == DMCollection) do  join retArr obj.defMeshes
	    if (classOf obj == CSolver) do join retArr obj.constraints
	    if (classOf obj == RPCollection) do join retArr obj.ropes
	    if (classOf obj == CLCollection) do join retArr obj.cloths
	    if (classOf obj == RBCollection) do join retArr obj.RigidBodies
	   ) 
	 )
	retArr
   )
  --------------------------------------------------------------------------------------------
  fn updateReactorState i = print "predict 8)"
  -----------------------------------------------------------------------------------------------------------------
  old = true
  containers = #()
  if symcontainer != undefined do for i in symcontainer do for j in i[16] do append containers j
  for i in containers do
   (
    try(if (not isDeleted i) do old = false)
	catch()
   )
  if containers.count==0 do old = false
  if currentsym==undefined do currentsym = 1
  if (symcontainer == undefined) or old do
   (
    symcontainer = #(#("",(animationrange.start.frame as integer),(animationrange.end.frame as integer),15,1.0,0.0,0.0,-981.0,false,true,0.01,0.01,100.0,1.0,true,#(),5.0,0.1,true,true,false,true,#()))
	for i in objects do if (isEntity i) do append symcontainer[1][16] i
   )
  -------------------------------------------------------------------------------------------------------------------------------------
  if (classOf batchSettings) != BitArray do batchSettings = #{1,3..4}
  ------------------------------------------------------------------------------------------------------------------------------   
  mh = symcontainer.count
  rollout mainCoreRoll "Simulation manager"
   (
    group "Setup simulations"
	 (
  	  label lbl1 "Name:" across:2 align:#left
	  edittext curName "" offset:[-60,0] width:150
  	  multiListbox curSim "" height:mh
	  checkBox hIn "Hide inactive nodes" checked:true
  	  button new "New" width:65 across:2
  	  button remN "Remove" width:65 enabled:false
	 )
	button saveBtn "Save" width:50 across:3
  	button loadBtn "Load" width:50
	button closeBtn "Close" width:50
	on loadBtn pressed do
	 (
	  appender = #()
	  fName = getOpenFileName caption:"Reactor core control: load settings" types:"Reactor settings (*.rcc)|*.rcc|"
	  if fname != undefined do
	   (
        rccFile = openFile fName mode:"r"
	    tmp = readLine rccFile
		if tmp == "[SimulationList]"
		 then
		  (
	       symNum = 0
		   curNum = 0
		   symIndex = 1
		   headerFinished = false
		   while not (eof rccFile) do
	        (
			 tmp = readline rccFile
		     if ((findString tmp "[Simulation_") == undefined) and (not headerFinished)
			  then
			   (
			    append appender #()
				symNum += 1
				appender[symNum][1] = tmp
			   )
			  else
			   (
			    headerFinished = true
			   )
			 if ((findString tmp "[Simulation_") == undefined) and headerFinished
			  then
			   (
			    symIndex += 1
				if tmp != "[EndSettings]" do appender[curNum][symIndex] = tmp
			   )
			  else
			   (
			    if headerFinished do
				 (
				  curNum += 1
				  symIndex = 1
				 )
			   )
	        )
	       for i in appender do for j = 2 to 23 do
		    (
			 if j==2 or j==3 or j==4 do i[j] = i[j] as integer
			 if j==5 or j==6 or j==7 or j==8 or j==11 or j==12 or j==13 or j==14 or j==17 or j==18 do i[j] = i[j] as float
			 if i[j] == "true" do i[j] = true
			 if i[j] == "false" do i[j] = false
			 if j==16 do
			  (
			   i[j] = filterString i[j] " "
			   for k = 1 to i[j].count do i[j][k] = maxOps.getNodeByHandle (i[j][k] as integer)
			  )
			 if j==23 do
			  (
			   i[j] = filterString i[j] " "
			   for k = 1 to i[j].count do
			    (
				 i[j][k] = filterString i[j][k] "_"
				 i[j][k][1] = maxOps.getNodeByHandle (i[j][k][1] as integer)
				 i[j][k][2] = maxOps.getNodeByHandle (i[j][k][2] as integer)
				)
			  )
			)
		   close rccFile
		   join symcontainer appender
		   updateReactorState currentSym
		  )
		 else
		  (
		   print "Invalid settings file"
		  )
	   )
	 )
	on saveBtn pressed do
	 (
	  fName = getSaveFileName caption:"Reactor core control: save settings" types:"Reactor settings (*.rcc)|*.rcc|"
	  if fName != undefined do
	   (
	    rccFile = createFile fName
		format "%" "[SimulationList]\n" to:rccFile
		for i in currentsym do format "%" (symcontainer[i][1] + "\n") to:rccFile
		for i in currentsym do
		 (
		  format "%" ("[Simulation_" + symcontainer[i][1] + "]\n") to:rccFile
		  for j=2 to symcontainer[i].count do
		   (
		    if j == 16 do
			 (
			  for k in symcontainer[i][16] do
			   (
			    format "%" k.inode.handle to:rccFile
			    format "%" " " to:rccFile
			   )
			 )			 
			if j == 23 do
			 (
			  for k in symcontainer[i][23] do
			   (
			    format "%" k[1].inode.handle to:rccFile
				format "%" "_" to:rccFile
				format "%" k[2].inode.handle to:rccFile
				format "%" " " to:rccFile
			   )
			 )
			if (j != 16) and (j != 23) do format "%" symcontainer[i][j] to:rccFile
			format "%" "\n" to:rccFile
		   )
		 )
		format "%" "[EndSettings]" to:rccFile
		close rccFile
		curName.visible = false
		lbl1.text = ((currentsym as array).count as string) + " simulations saved"
	   )
	 )
	on hIn changed state do
	 (
      batchSettings[5] = state
	  updateReactorState(currentSym)
     )
	on remN pressed do
	 (
	  try(removeRollout entCoreRoll)
	  catch()
	  try(removeRollout rccf.rollouts[5])
	  catch()
	  n = curSim.selection as array
	  for i in n do symcontainer[i] = undefined
	  for i=1 to n.count do deleteItem symcontainer (findItem symcontainer undefined)
	  curSim.selection = #{1}
	  updateReactorState 1
	 )
	on new pressed do
	 (
	  try(removeRollout entCoreRoll)
	  catch()
	  try(removeRollout rccf.rollouts[5])
	  catch()
      append symcontainer #("",(animationrange.start.frame as integer),(animationrange.end.frame as integer),(15 as integer),(1 as float),(0 as float),(0 as float),(-9810 as float),false,true,0.01,0.01,(1000 as float),(1 as float),true,#(),(5 as float),(0.1 as float),true,true,false,true,#())
	  curSim.selection = #{symcontainer.count}
	  currentsym = #{symcontainer.count}
      updateReactorState #{symcontainer.count}
	 )
	on curName changed val do
	 (
	  if (currentSym as array).count == 1 do
	   (
	    symcontainer[(currentSym as array)[1]][1] = val
	    updateReactorState currentSym
	   )
	 )
	on curSim selectionEnd do 
	 (
	  try(contCoreRoll.cont.selection = #{})
	  catch()
	  try(rccf.rollouts[4].selection = #{})
	  catch()
	  try(removeRollout entCoreRoll)
	  catch()
	  try(removeRollout rccf.rollouts[5])
	  catch()
	  --try(removeRollout (rccf.rollouts[4]))
	  --catch()
	  updateReactorState curSim.selection
	 )
	on closebtn pressed do
	 (
	  try(cui.unregisterDialogBar rccf)
  	  catch()
	  try(closeRollOutFloater rccf)
  	  catch()
	  try(cui.commandPanelOpen = true)
  	  catch()
	  callbacks.removeScripts()
	 )
   )--end mainCoreRoll
  ------------------------------------------------------------------------------------
  rollout setCoreRoll "Simulation settings"
   (
	label slab "Start frame" pos:[25,10]
  	spinner startF pos:[90,10] width:100 range:[-100000,100000,0] type:#integer scale:1
	label elab "End frame" pos:[25,30]
  	spinner endF pos:[90,30] width:100 range:[-100000,100000,100] type:#integer scale:1
	label subl "Substeps" pos:[25,50]
  	spinner sub pos:[90,50] width:100 range:[1,1000,15] type:#integer scale:1
	label tslab "Time scale" pos:[25,70]
  	spinner ts pos:[90,70] width:100 range:[0.01,1000,1] type:#float scale:0.01
  	GroupBox grp3 "Gravity" pos:[5,90] width:80 height:80
	label gxl "X" pos:[10,110]
  	spinner xg pos:[20,110] width:60 range:[-100000,100000,0] type:#float scale:1
	label gyl "Y" pos:[10,130]
  	spinner yg pos:[20,130] width:60 range:[-100000,100000,0] type:#float scale:1
	label gzl "Z" pos:[10,150]
  	spinner zg pos:[20,150] width:60 range:[-100000,100000,-981] type:#float scale:1
  	spinner ws "World scale 1m = " pos:[45,180] width:100 enabled:true range:[0,100000,100]
  	spinner ct "Collision tolerance " pos:[47,203] width:100 range:[0.0001,100000,1]
  	label lbl5 "MAX units" pos:[148,180] width:50
  	checkbox sf "Simulate friction" pos:[92,96] checked:false
  	checkbox da "Add drag action" pos:[92,115] checked:true
	label llab "Linear" pos:[92,133]
  	spinner ld pos:[135,133] width:60 range:[0,100,0.01] scale:0.01
	label rlab "Angular" pos:[92,153]
  	spinner ad pos:[135,153] width:60 range:[0,100,0.01] scale:0.01
	checkbox addD "Add deactivator" pos:[7,225] checked:true
	label lsf "Short Frequency" pos:[10,245]
	spinner dsf range:[0.1,100,5] scale:0.1 pos:[90,245]
	label llf "Long Frequency" pos:[10,265]
	spinner dlf range:[0.1,100,0.1] scale:0.1 pos:[90,265]
	button cr "CR" width:20 height:20 pos:[3,17]
	on cr pressed do
	 (
  	  symcontainer[(currentsym as array)[1]][2]=animationRange.start
	  symcontainer[(currentsym as array)[1]][3]=animationRange.end
   	  updateReactorState currentsym
	 )
	on dlf entered do
	 (
	  symcontainer[(currentsym as array)[1]][18]=dlf.value
  	  updateReactorState currentsym
	 )
	on dsf entered do
	 (
	  symcontainer[(currentsym as array)[1]][17]=dsf.value
  	  updateReactorState currentsym
	 )
	on addD changed state do
	 (
	  symcontainer[(currentsym as array)[1]][15]=state
  	  updateReactorState currentsym
	 )
	on ct entered do
	 (
	  symcontainer[(currentsym as array)[1]][14]=ct.value
  	  updateReactorState currentsym
	 )
	on ws entered do
	 (
	  symcontainer[(currentsym as array)[1]][13]=ws.value
  	  updateReactorState currentsym
	 )
	on ad entered do
	 (
	  symcontainer[(currentsym as array)[1]][12]=ad.value
  	  updateReactorState currentsym
	 )
	on ld entered do
	 (
	  symcontainer[(currentsym as array)[1]][11]=ld.value
  	  updateReactorState currentsym
	 )
	on da changed state do
	 (
	  symcontainer[(currentsym as array)[1]][10]=state
   	  updateReactorState currentsym
	 )
	on sf changed state do
	 (
	  symcontainer[(currentsym as array)[1]][9]=state
  	  updateReactorState currentsym
	 )
	on xg entered do
	 (
	  symcontainer[(currentsym as array)[1]][6]=xg.value
  	  updateReactorState currentsym
	 )
	on yg entered do
	 (
	  symcontainer[(currentsym as array)[1]][7]=yg.value
  	  updateReactorState currentsym
	 )
	on zg entered do
	 (
	  symcontainer[(currentsym as array)[1]][8]=zg.value
  	  updateReactorState currentsym
	 )
	on ts entered do
	 (
	  symcontainer[(currentsym as array)[1]][5]=ts.value
  	  updateReactorState currentsym
	 )
	on sub entered do
	 (
	  symcontainer[(currentsym as array)[1]][4]=sub.value
  	  updateReactorState currentsym
	 )
	on startF entered do
	 (
	  symcontainer[(currentsym as array)[1]][2] = startF.value
	  if symcontainer[(currentsym as array)[1]][2] >= symcontainer[(currentsym as array)[1]][3] do symcontainer[(currentsym as array)[1]][3] = startF.value+1
	  updateReactorState currentsym
	 )
	on endF entered do
	 (
	  symcontainer[(currentsym as array)[1]][3] = endF.value
	  if symcontainer[(currentsym as array)[1]][3] <= symcontainer[(currentsym as array)[1]][2] do symcontainer[(currentsym as array)[1]][2] = endF.value-1
	  updateReactorState currentsym
	 )
   )--end setCoreRoll
------------------------------------------------------------
  rollout contCoreRoll "Included containers"
   (
    multiListBox cont height:conth
   )
--------------------------------------------------------------------------------------------------------------------------------- 
  rollout entCoreRoll "Included entities"
   (
    multiListBox ent height:enth
	checkBox collEna "Collision enabled" align:#center enabled:false
	button collideSel "Enable all selected" enabled:false
	button uncollideSel "Disable all selected" enabled:false
	button collSet1 "Set 1" across:2
	button collSet2 "Set 2"
	label s1 "0" across:2
	label s2 "0"
	button setEna "Enable sets" enabled:false
	button setDis "Disable sets"  enabled:false
	--button collTable "Collision table"
	label collNum "undefined"
	on setDis pressed do
	 (
	  remArr = #()
	  for i=1 to symcontainer[(currentsym as array)[1]][23].count do
	   (
	    i1 = findItem objSel (symcontainer[(currentsym as array)[1]][23][i][1])
		i2 = findItem objSel (symcontainer[(currentsym as array)[1]][23][i][2])
		if (set1[i1] and set2[i2]) or (set1[i2] and set2[i1]) do append remArr i
	   )
	  for i=1 to remArr.count do deleteItem (symcontainer[(currentsym as array)[1]][23]) (remArr.count-i+1)
	  updateReactorState currentsym
	 )

	on setEna pressed do
	 (
	  for i in set1 do for j in set2 do
	   (
	    if objSel[i].handle < objSel[j].handle then
		 (
		  firstObj = objSel[i]
		  secondObj = objSel[j]
		 )
																														   else
		 (
		  firstObj = objSel[j]
		  secondObj = objSel[i]
		 )
		needToAppend = true
		for n in symcontainer[(currentsym as array)[1]][23] do if needToAppend do if n[1]==firstObj and n[2]==secondObj do needToAppend = false
		if needToAppend do append (symcontainer[(currentsym as array)[1]][23]) #(firstObj,secondObj)
	   )
	  updateReactorState currentsym
	 )
	on collSet2 pressed do
	 (
	  set2 = ent.selection
	  set1 = set1 - set2
	  updateReactorState currentsym
	 )
	on collSet1 pressed do
	 (
	  set1 = ent.selection
	  set2 = set2 - set1
	  updateReactorState currentsym
	 )
	on uncollideSel pressed do
	 (
	  remArr = #()
	  for i=1 to symcontainer[(currentsym as array)[1]][23].count do
	   (
	    i1 = findItem objSel (symcontainer[(currentsym as array)[1]][23][i][1])
		i2 = findItem objSel (symcontainer[(currentsym as array)[1]][23][i][2])
		if ent.selection[i1] and ent.selection[i2] do append remArr i
	   )
	  for i=1 to remArr.count do deleteItem (symcontainer[(currentsym as array)[1]][23]) (remArr.count-i+1)
	  updateReactorState currentsym
	 )
	on collideSel pressed do
	 (
	  for i=1 to (ent.selection as array).count-1 do for j=i+1 to (entcoreroll.ent.selection as array).count do
	   (
	    if objSel[(ent.selection as array)[i]].handle < objSel[(entcoreroll.ent.selection as array)[j]].handle then
		 (
		  firstObj = objSel[(entcoreroll.ent.selection as array)[i]]
		  secondObj = objSel[(entcoreroll.ent.selection as array)[j]]
		 )
																														   else
		 (
		  firstObj = objSel[(entcoreroll.ent.selection as array)[j]]
		  secondObj = objSel[(entcoreroll.ent.selection as array)[i]]
		 )
		needToAppend = true
		for n in symcontainer[(currentsym as array)[1]][23] do if needToAppend do if n[1]==firstObj and n[2]==secondObj do needToAppend = false
		if needToAppend do append (symcontainer[(currentsym as array)[1]][23]) #(firstObj,secondObj)
	   )
	  updateReactorState currentsym
	 )
	on collEna changed state do
	 (
	  if state then
	   (
        append symcontainer[(currentsym as array)[1]][23] #(firstObj,secondObj)
		rmCollIndex = symcontainer[(currentsym as array)[1]][23].count
       )
	           else deleteItem symcontainer[(currentsym as array)[1]][23] rmCollIndex
	  updateReactorState(currentsym)
	 )
	on ent selectionEnd do
	 (
	  contCoreRoll.cont.selection = #{}
	  clearSelection()
	  try(closeRolloutFloater RCTPropertiesFloater)
	  catch()
	  cui.commandPanelOpen = false
	  tmp = #()
	  for i in (ent.selection as array) do append tmp objSel[i]
	  for i in tmp do selectMore i
	  if tmp.count == 1 then
	   (
	    if isRB tmp[1] then 
		 (
		  --print "what a fuck?"
		  macros.run "reactor" "rctOpenPropertyEditor"
		 )
		               else
		 (
		  setCommandPanelTaskMode mode:#modify
		  cui.commandPanelOpen = true
		 )
		)
		                else
	    (
		 state = true
		 for i in tmp do if not(isRB i) do state = false
		 if state do macros.run "reactor" "rctOpenPropertyEditor"
		)
	  if (entCoreRoll.ent.selection as array).count > 2 then
		(
		 collideSel.enabled = true
		 uncollideSel.enabled = true
		)
		                                                  else
		(
		 entCoreRoll.collideSel.enabled = false
		 entCoreRoll.uncollideSel.enabled = false
		)
	  if (ent.selection as array).count == 2 and not(isConst objsel[(ent.selection as array)[1]]) and not(isConst objsel[(ent.selection as array)[2]]) then
	   (
        collena.enabled = true
		if (objSel[(ent.selection as array)[1]]).handle > (objSel[(ent.selection as array)[2]]).handle then
		 (
		  firstObj = (objSel[(ent.selection as array)[2]])
		  secondObj = (objSel[(ent.selection as array)[1]])
 		 )
																									   else
		 (
		  firstObj = (objSel[(ent.selection as array)[1]])
		  secondObj = (objSel[(ent.selection as array)[2]])
		 )
        needToAdd = true
		for i=1 to symcontainer[(currentsym as array)[1]][23].count do if symcontainer[(currentsym as array)[1]][23][i][1] == firstObj and symcontainer[(currentsym as array)[1]][23][i][2] == secondObj then
		 (
          needToAdd = false
		  rmCollIndex = i
         )
		collena.state = not needToAdd
       )
	                                                                                                                                                   else
	   (
        collena.enabled = false
		collena.state = false
       )
	 )
   )
---------------------------------------------------------------------------------------------- 
  rollout contCoreRoll "Included containers"
   (
    multiListBox cont height:conth
  	pickButton addbtn "Pick" width:50 height:21 filter:isEntity across:3
  	button addS "Add sel." width:50 height:21
  	button remC "Remove" width:50 height:21
	on remC pressed do
	 (
	  tmp = #()
	  try(removeRollout entCoreRoll)
	  catch()
	  try(removeRollout rccf.rollouts[5])
	  catch()
	  for i in (cont.selection as array) do append tmp (symcontainer[(currentsym as array)[1]][16][i])
	  for i in tmp do deleteItem symcontainer[(currentsym as array)[1]][16] (findItem symcontainer[(currentsym as array)[1]][16] i)
	  updateReactorState(currentsym)
	 )
	on addS pressed do 
	 (
	  if (isEntity $) do if (findItem symcontainer[(currentsym as array)[1]][16] $)==0 do append symcontainer[(currentsym as array)[1]][16] $
	  if (classOf $ == ObjectSet) do for i in $ do if (isEntity i) do if (findItem symcontainer[(currentsym as array)[1]][16] i)==0 do append symcontainer[(currentsym as array)[1]][16] i
  	  updateReactorState(currentsym)
	 )
	on addbtn picked obj do
	 (
	  if (findItem symcontainer[(currentsym as array)[1]][16] obj)==0 do append symcontainer[(currentsym as array)[1]][16] obj
	  updateReactorState(currentsym)
	 )
	on cont selectionEnd do
	 (
	  try(entCoreRoll.ent.selection = #{})
	  catch()
	  clearSelection()
	  try(closeRolloutFloater RCTPropertiesFloater)
	  catch()
	  for i in (cont.selection as array) do selectMore (symcontainer[(currentsym as array)[1]][16][i])
	  if (cont.selection as array).count==1 then
	   (
	    setCommandPanelTaskMode mode:#modify
	    cui.commandPanelOpen = true
		contSel = #($)
	   )
	                                        else
	   (
	    cui.commandPanelOpen = false
		contSel = ($ as array)
	   )
	  objSel = getEnts(contSel)
	  for i in rccf.rollouts do if i == entCoreRoll do removeRollout i
	  if objSel.count !=0 do
	   (
	    enth = objSel.count
		if enth>32 do enth = 32
		nameArr = #()
		for i in objSel do append NameArr i.name
		addRollout entCoreRoll rccf
		entCoreRoll.ent.items = nameArr
        entCoreRoll.collNum.text = (symcontainer[(currentsym as array)[1]][23].count as string) + " collisions enabled"
	   )
	 )
   )
---------------------------------------------------------------------------------------------
/*  rollout subTransCoreRoll "Subtransform manager"
   (
    group "Creation"
	 (
	  button creRes "Create/restore" width:100
	  checkBox IDonly "Material ID only" across:2 offset:[15,0]
	  spinner mtlID type:#integer range:[1,65535,1] width:50 offset:[-15,0]
  	  spinner nth "Every n'th" type:#integer range:[1,25,1] width:50 offset:[-5,0]
	 )
	group "Controls"
	 (
	  checkButton enaTrans "Enabled" checked:true width:100
	  checkButton hideTrans "Hide" checked:true width:100
	  button bakeTrans "Bake animation" width:100
	  spinner bs "Start" range:[-100000,100000,0] across:2 align:#left type:#integer width:85 offset:[-5,0]
	  spinner be "End" range:[-100000,100000,100] type:#integer width:85 offset:[-10,0]
	  button loopIn "Loop animation"
	  spinner lf "blend duration" range:[1,1000,10] type:#integer width:75
	  label subState "No subtransform found"
	 ) 
   )*/
----------------------------------------------------------------------------------------------
  rollout animCoreRoll "Animation"
   (
    button tstWr "Test world" width:100
	button proc "Create animation" width:100
	checkBox viewPUpdate "Update viewport" checked:true
	checkBox saveBefore "Save before simulation" checked:true
	checkBox qm "Quiet mode"
	checkBox alarm "Alarm when finished" checked:true
	on proc pressed do
	 (
	  clearSelection()
	  if saveBefore.state then saveMaxFile (maxFilePath + "rccBackup" + maxFileName) useNewFile:false
	  if (currentsym as array).count==1
	   then
	    (
		 reactor.createAnimation false --(symcontainer[(currentsym as array)[1]][21])
		)
	   else
	    (
		 tmpArr = currentsym as array
		 for i in tmpArr do
		  (
		   updateReactorState i
		   reactor.updateViewports = batchSettings[1]
		   reactor.createAnimation batchSettings[3]
		  )
		 currentSym = tmpArr as bitArray
		 updateReactorState currentSym
		)
	  if alarm.state do shellLaunch "sndrec32" "/play D:\WINDOWS\Media\Windows XP Startup.wav"
	 )
	on tstWr pressed do reactor.analyzeWorld()
	on viewPUpdate changed state do
	 (
	  if proc.caption == "Create animation" then symcontainer[(currentsym as array)[1]][19]=state
	                                        else batchSettings[1] = state
      updateReactorState currentsym 
	 )
	on saveBefore changed state do
	 (
	  if proc.caption == "Create animation" then symcontainer[(currentsym as array)[1]][20]=state
	                                        else batchSettings[2] = state
  	  updateReactorState currentsym
	 )
	on qm changed state do
	 (
	  if proc.caption == "Create animation" then symcontainer[(currentsym as array)[1]][21]=state
	                                        else batchSettings[3] = state
  	  updateReactorState currentsym
	 )
	on alarm changed state do
	 (
	  if proc.caption == "Create animation" then symcontainer[(currentsym as array)[1]][22]=state
	                                        else batchSettings[4] = state
  	  updateReactorState currentsym
	 )
   )
  --------------------------------------------------------------------------   
  fn updateReactorState i =
   (
	clearSelection()
	cui.CommandPanelOpen = false
	if classOf i == integer do i = #{i}
	currentsym = i
	if (currentsym as array).count==1 do
	 (
	  allEnts = #()
	  for o in symcontainer[(currentsym as array)[1]][16] do if not (isdeleted o) do if (classOf o)!=CSolver do append allEnts o
	  allEnts = getEnts allEnts
	  for m=1 to allEnts.count-1 do for j=m+1 to allEnts.count do reactor.disableCollisions allEnts[m] allEnts[j]
	 )
	for k in symcontainer do
	 (
      tmp = #()
	  for j in k[16] do
	   (
	    delState = false
		try(delState=j.isDeleted)
		catch()
		if delState or (j==undefined) do append tmp j
	   )
	  print tmp
	  for j in tmp do deleteItem k[16] (findItem k[16] j)
     )
	numrolls = rccf.rollouts.count
	rollNames = #()
	rollStates = #{}
	contSel = contCoreRoll.cont.selection
	entSel = entCoreRoll.ent.selection
	entItems = entCoreRoll.ent.items
	for j=1 to numrolls do
	 (
	  rollNames[j] = rccf.rollouts[j].name
	  rollStates[j] = rccf.rollouts[j].open
	 )
	for j=1 to numrolls do removeRollout rccf.rollouts[1]
    tmp = #()
	for j=1 to symcontainer.count do append tmp symcontainer[j][1]
    mh = symcontainer.count
	addRollout mainCoreRoll rccf
    mainCoreRoll.cursim.items = tmp
	mainCoreRoll.cursim.selection = i
    addRollout animCoreRoll rccf
	if (i as array).count == 1 then
	 (
	  i = (i as array)[1]
      if i>symcontainer.count do
	   (
	    i = symcontainer.count
	    currentsym = i
	   )
	  if symcontainer[i].count == 16 do
	   (
	    symcontainer[i][17] = (5 as float)
		symcontainer[i][18] = (0.1 as float)
		symcontainer[i][19] = true
		symcontainer[i][20] = true
		symcontainer[i][21] = false
		symcontainer[i][22] = true
		symcontainer[i][23] = #()
	   )
	  mainCoreRoll.curName.enabled = true
	  mainCoreRoll.lbl1.text = "Name:"
  	  mainCoreRoll.curName.visible = true
	  mainCoreRoll.curName.text = mainCoreRoll.cursim.items[(mainCoreRoll.cursim.selection as array)[1]]
	  animCoreRoll.tstWr.enabled = true
	  animCoreRoll.proc.caption = "Create animation"
	  addRollout setCoreRoll rccf
      setCoreroll.startF.value = symcontainer[i][2]
	  reactor.startFrame = symcontainer[i][2]
	  setCoreroll.endF.value = symcontainer[i][3]
	  reactor.endFrame = symcontainer[i][3]
	  setCoreRoll.sub.value = symcontainer[i][4]
	  reactor.substeps = symcontainer[i][4]
	  setCoreroll.ts.value = symcontainer[i][5]
	  reactor.timeScale = symcontainer[i][5]
	  setCoreroll.xg.value = symcontainer[i][6]
	  setCoreroll.yg.value = symcontainer[i][7]
	  setCoreroll.zg.value = symcontainer[i][8]
	  reactor.gravity = [symcontainer[i][6],symcontainer[i][7],symcontainer[i][8]]
	  setCoreroll.sf.state = symcontainer[i][9]
	  reactor.simulatefriction = symcontainer[i][9]
	  setCoreroll.da.state = symcontainer[i][10]
	  reactor.useDragAction = symcontainer[i][10]
      setCoreroll.ld.enabled = symcontainer[i][10]
      setCoreroll.ad.enabled = symcontainer[i][10]
	  setCoreroll.ld.value = symcontainer[i][11]
	  reactor.linearDrag = symcontainer[i][11]
	  setCoreroll.ad.value = symcontainer[i][12]
	  reactor.angularDrag = symcontainer[i][12]
	  setCoreroll.ws.value = symcontainer[i][13]
	  reactor.worldScale = symcontainer[i][13]
	  setCoreroll.ct.value = symcontainer[i][14]
	  reactor.collisionTolerance = symcontainer[i][14]
	  setCoreRoll.addD.state = symcontainer[i][15]
	  reactor.addDeactivator = symcontainer[i][15]
	  setCoreRoll.dsf.enabled = symcontainer[i][15]
	  setCoreRoll.dlf.enabled = symcontainer[i][15]
	  setCoreRoll.dsf.value = symcontainer[i][17]
	  reactor.deactivatorShortFrequency = symcontainer[i][17]
	  setCoreRoll.dlf.value = symcontainer[i][18]
	  reactor.deactivatorLongFrequency = symcontainer[i][18]
	  animCoreRoll.viewPUpdate.state = symcontainer[i][19]
	  reactor.updateViewports = symcontainer[i][19]
	  animCoreRoll.saveBefore.state = symcontainer[i][20]
	  animCoreRoll.qm.state = symcontainer[i][21]
	  animCoreRoll.alarm.state = symcontainer[i][22]
	  for j in objects do if isEntity j do j.disabled = true
	  tmp = #()
	  for j in symcontainer[i][16] do
	   (
	    j.disabled = false
	    append tmp j.name	  
	   )
	  conth = tmp.count
  	  addRollout contCoreRoll rccf
  	  contCoreRoll.cont.items = tmp
      contCoreRoll.cont.selection = contSel
	  for m in rollNames do if m == "entCoreRoll" do
	   (
        addRollout entCoreRoll rccf
    	entCoreRoll.ent.items = entItems
		entCoreRoll.ent.selection = entSel
		entCoreRoll.s1.text = (set1 as array).count as string
		entCoreRoll.s2.text = (set2 as array).count as string
		if (set1 as array).count!=0 and (set2 as array).count!=0 then
		 (
		  entCoreRoll.setEna.enabled = true
		  entCoreRoll.setDis.enabled = true
		 )
		                                                         else
		 (
		  entCoreRoll.setEna.enabled = false
		  entCoreRoll.setDis.enabled = false
		 )
	    if (entCoreRoll.ent.selection as array).count == 2 and not(isConst objsel[(entCoreRoll.ent.selection as array)[1]]) and not(isConst objsel[(entCoreRoll.ent.selection as array)[2]])
		 then
	      (
           entCoreRoll.collena.enabled = true
		   if (objSel[(entCoreRoll.ent.selection as array)[1]]).handle > (objSel[(entCoreRoll.ent.selection as array)[2]]).handle
		    then
		     (
		      firstObj = (objSel[(entCoreRoll.ent.selection as array)[2]])
		      secondObj = (objSel[(entCoreRoll.ent.selection as array)[1]])
 		     )
			else
		     (
		      firstObj = (objSel[(entCoreRoll.ent.selection as array)[1]])
		      secondObj = (objSel[(entCoreRoll.ent.selection as array)[2]])
		     )
          needToAdd = true
		  for i=1 to symcontainer[(currentsym as array)[1]][23].count do if symcontainer[(currentsym as array)[1]][23][i][1] == firstObj and symcontainer[(currentsym as array)[1]][23][i][2] == secondObj then
		   (
            needToAdd = false
		    rmCollIndex = i
           )
		  entCoreRoll.collena.state = not needToAdd
         )
	     else
	      (
           entCoreRoll.collena.enabled = false
		   entCoreRoll.collena.state = false
          )
		)
      symMembers = getEnts symcontainer[(currentsym as array)[1]][16]
	  rmArr = #()
	  for m = 1 to symcontainer[(currentsym as array)[1]][23].count do
	   (
		fp = false
		sp = false
	    for n in symMembers do if n == symcontainer[(currentsym as array)[1]][23][m][1] do fp = true
	    for n in symMembers do if n == symcontainer[(currentsym as array)[1]][23][m][2] do sp = true
		if not(fp and sp) do append rmArr m
	   )
	  offset = 0 
	  for m in rmArr do
	   (
        deleteItem symcontainer[(currentsym as array)[1]][23] (m-offset)
		offset += 1
       )
	  for m in symcontainer[(currentsym as array)[1]][23] do reactor.enableCollisions m[1] m[2]
      entCoreRoll.collNum.text = (symcontainer[(currentsym as array)[1]][23].count as string) + " collisions enabled"
	 )
	                          else
     (
  	  mainCoreRoll.lbl1.text = ((((mainCoreRoll.cursim.selection as array).count) as string) + " simulations selected")
	  mainCoreRoll.curName.visible = false
  	  mainCoreRoll.curName.enabled = false
	  animCoreRoll.tstWr.enabled = false
	  animCoreRoll.proc.caption = "Batch simulation"
	  animCoreRoll.viewPUpdate.state = batchSettings[1]
	  animCoreRoll.saveBefore.state = batchSettings[2]
	  animCoreRoll.qm.state = batchSettings[3]
	  animCoreRoll.alarm.state = batchSettings[4]
	 )
	for j=1 to rollNames.count do
     (
	  for k in rccf.rollouts do
	   (
	    if rollNames[j]==k.name do k.open = rollStates[j]
	   )
	 )
	mainCoreRoll.remN.enabled = (symcontainer.count > 1)
	mainCoreRoll.hIn.state = batchSettings[5]
	inactiveArr = #()
	activeArr = #()
	for k=1 to symcontainer.count do
	 (
	  if currentsym[k]
	   then
	    (
		 for l in symcontainer[k][16] do
		  (
		   append activeArr l
		   for m in getEnts(l) do append activeArr m
		  )
		)
	   else
	    (
		 for l in symcontainer[k][16] do
		  (
		   append inactiveArr l
		   for m in getEnts(l) do append inactiveArr m
		  )
		)
	 )
	if mainCoreRoll.hIn.state do for k in inactiveArr do hide k
	for k in activeArr do unhide k
   )
  ------------------------------------------------------------------------------------------------------
  fn checkNewNode nNode =
   (
	if ((currentSym as array).count == 1) do
     if (isEntity nNode) do
      (
	   append symcontainer[(currentSym as array)[1]][16] nNode
	   updateReactorState currentsym
	  )
   )
  ---------------------------------------------------------------------------------------
  fn checkDoomedNode dNode =
   (
    if ((currentSym as array).count == 1) do
	 if (isEntity dNode) do
      (
	   di = findItem (symcontainer[(currentSym as array)[1]][16]) dNode
       if di!=undefined do
        (
		 deleteItem (symcontainer[(currentSym as array)[1]][16]) di
		 updateReactorState currentsym
		)
	  )	
   )
  -------------------------------------------------------------------------------------------------